﻿using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CellGrid
{
    public partial class Form1 : Form
    {     
        private DataTable dt;
        private bool[] str = { true, false };
        private bool CheckBoxValue = false;

        public Form1()
        {
            InitializeComponent();

            #region DATASOURCE
            dt = new DataTable();
            dt.Columns.Add("Column1",typeof(string));
            dt.Columns.Add("Column2", typeof(bool));
            dt.Columns.Add("Column3", typeof(string));
            dt.Columns.Add("Column4", typeof(string));
            dt.Columns.Add("Column5", typeof(string));

            Random r = new Random(123421);
            for (int row = 0; row < 20; row++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = "row" + (row + 1) + "col1";
                dr[1] = str[r.Next(0, 2)];
                dr[2] = "row" + (row + 1) + "col3";
                dr[3] = "row" + (row + 1) + "col4";
                dr[4] = "row" + (row + 1) + "col5";
                dt.Rows.Add(dr);
            }
            #endregion

            this.gridGroupingControl1.DataSource = dt;

            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("Column4");

            #region Checkbox Settings
            this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
            this.gridGroupingControl1.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(gridGroupingControl1_SaveCellText);
            this.gridGroupingControl1.TableControlCellClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);
            this.gridGroupingControl1.TableControlCheckBoxClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCheckBoxClick);
            this.gridGroupingControl1.TableControl.MouseUp += new MouseEventHandler(TableControl_MouseUp);
            #endregion
        }

        void TableControl_MouseUp(object sender, MouseEventArgs e)
        {
            int row, col;
            this.gridGroupingControl1.TableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
            GridTableCellStyleInfo style = this.gridGroupingControl1.TableControl.Model[row, col];

            IMouseController controller;
            this.gridGroupingControl1.TableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

            if (controller != null && controller.Name == "DragGroupHeader")
            {
                if (this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count > 0 && col == this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count + 1)
                    this.gridGroupingControl1.TableControl.GetCellRenderer(row, col - this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count).RaiseMouseUp(row, col - this.gridGroupingControl1.TableDescriptor.GroupedColumns.Count, e);
                else
                    this.gridGroupingControl1.TableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);

            }
        }

        bool chk, check = false;
        ArrayList ht = new ArrayList();
        void gridGroupingControl1_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
            if (style.Enabled)
            {
                int column = this.gridGroupingControl1.TableModel.NameToColIndex("Column2");
                Console.WriteLine("CheckBoxClicked");
                if (style.Enabled && style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
                {
                    chk = (bool)this.gridGroupingControl1.TableModel[style.TableCellIdentity.RowIndex, column].CellValue;
                    e.TableControl.BeginUpdate();
                    foreach (Record rec in e.TableControl.Table.Records)
                    {
                        int rowIndex = e.TableControl.Table.DisplayElements.IndexOf(rec);
                        GridTableCellStyleInfo rowStyle = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(rowIndex, column);
                        if (rowStyle.Enabled)
                            rec.SetValue("Column2", !chk);
                    }
                    e.TableControl.EndUpdate(true);
                }
                if (style.Enabled && (style.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell || style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell) && style.TableCellIdentity.Column.Name == "Column2")
                {
                    Record currentRecord = style.TableCellIdentity.DisplayElement.GetRecord();
                    bool curStatus = bool.Parse(style.Text);
                    e.TableControl.BeginUpdate();
                    foreach (Record r in e.TableControl.Table.Records)
                    {
                        if (r != currentRecord)
                        {
                            check = bool.Parse(r.GetValue(style.TableCellIdentity.Column.Name).ToString());
                            ht.Add(check);
                        }
                    }
                    e.TableControl.EndUpdate();
                    if (ht.Contains(curStatus) && !ht.Contains(!curStatus))
                    {
                        if (curStatus)
                            CheckBoxValue = false;
                        this.gridGroupingControl1.TableModel[2, column].CellValue = curStatus;
                    }
                    else if (!ht.Contains(curStatus))
                    {
                        this.gridGroupingControl1.TableModel[2, column].CellValue = curStatus;
                        CheckBoxValue = !curStatus;
                    }
                    ht.Clear();
                }
            }
            this.gridGroupingControl1.TableControl.Refresh();
        }

        void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        {
            GridTableCellStyleInfo style = e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex];
            if (style.Enabled)
            {
                if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && style.TableCellIdentity.Column.Name == "Column2")
                {
                    e.Inner.Cancel = true;
                }
                Console.WriteLine(e.Inner.RowIndex.ToString() + "TableControlCellClick");
            }
        }

        void gridGroupingControl1_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
            if (style.Enabled && style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
            {
                this.CheckBoxValue = bool.Parse(e.Text);
                e.Handled = true;
            }
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            GridTableCellStyleInfoIdentity id = e.TableCellIdentity as GridTableCellStyleInfoIdentity;
            Record record;
            if (id.DisplayElement.IsRecord())
            {
                record = id.DisplayElement.GetRecord();
                if (e.TableCellIdentity.ColIndex==4 && id.TableCellType == GridTableCellType.RecordFieldCell && record!=null && record.GetValue("Column3").Equals("row10col3"))
                {
                    e.Style.CellType = "CheckBox";
                    e.Style.CellValueType = typeof(bool);
                    e.Style.CellValue = CheckBoxValue;
                    e.Style.ReadOnly = false;
                    e.Style.CellAppearance = GridCellAppearance.Raised;
                    e.Style.Enabled = true;
                }
            }
            e.Handled = true;
        }
    }
}